tinyMCEPopup.requireLangPack();
var neolibura_view_count = 30;
var neolibura_search_type = "";
var neolibura_search_cond_key = {};
var neolibura_search_cond_mydocs = {};

function init() {
    tinyMCEPopup.resizeToInnerSize();

    // 閉じる
    j$('.close').click(function(){
        tinyMCEPopup.close();
    });

    // 自分のドキュメントを選択
    j$('.mydocs_select').click(function(){
        // タブ
        j$('#id_tab_key').hide();
        j$('#id_tab_mydocs').show();

        // 検索条件入力
        j$('#id_input_key').hide();
        j$('#id_input_mydocs').show();

        // 検索結果
        j$('#id_list_key').hide();
        j$('#no_docs_key').hide();

        if (j$('#id_docs_mydocs').html().length > 0) {
            // ドキュメントを表示
            j$('#id_mydoc_help').show();
            j$('#id_list_mydocs').show();
        }
        else {
            // メッセージを表示
            j$('#no_docs_mydocs').show();
        }
    });

    // キーワードを選択
    j$('.key_select').click(function(){
        // タブ
        j$('#id_tab_mydocs').hide();
        j$('#id_tab_key').show();

        // 検索条件入力
        j$('#id_input_mydocs').hide();
        j$('#id_input_key').show();
        j$('#id_mydoc_help').hide();

        // 検索結果
        j$('#id_list_mydocs').hide();
        j$('#no_docs_mydocs').hide();

        if (j$('#id_docs_key').html().length > 0) {
            // ドキュメントを表示
            j$('#id_list_key').show();
        }
        else {
            // メッセージを表示
            j$('#no_docs_key').show();
        }
    });

    // 自分のドキュメントを検索
    j$('#id_search_mydocs').click(function(){
        neolibura_search_type = 'lid';
        searchNew({
                   'lid': j$('#lid').val(),
                   'pw': j$('#pw').val()
        });
    });

    // キーワードで検索
    j$('#id_search_key').click(function(){
        neolibura_search_type = 'key';
        searchNew({
                   'key': j$('#key').val()
        });
    });

    // id, passwordの復元
    j$.Jookie.Initialise('rte_neolibura_login');
    var sLid = j$.Jookie.Get('rte_neolibura_login', 'lid');
    if (sLid == null || sLid.length == 0) {
        sLid = '';
    }
    var sSaveLogin = j$.Jookie.Get('rte_neolibura_login', 'savelogin');
    if (sSaveLogin == null || sSaveLogin.length == 0) {
        sSaveLogin = '0';
    }

    if (sSaveLogin != '1') {
        // クッキーで保存しない場合

        // クッキーをクリア
        j$.Jookie.Delete('rte_neolibura_login');
    }
    else if (tinyMCEPopup.getWindowArg('save_pass') != '1') {
        // システム設定で保存しない場合

        // パスワード以外を戻す
        j$('#lid').val(sLid);
        j$('#savelogin').attr('checked', 'checked');
    }
    else {
        // 復元
        j$('#lid').val(sLid);
        j$('#pw').val('***************');
        j$('#savelogin').attr('checked', 'checked');
    }

    // Entryキーのハンドリング
    j$('input').keypress(function(e) {
        if (e.which == 13) {
            if (j$('#id_tab_mydocs').css('display') != 'none') {
                neolibura_search_type = 'lid';
                searchNew({
                           'lid': j$('#lid').val(),
                           'pw': j$('#pw').val()
                });
                return false;
            }
            else {
                neolibura_search_type = 'key';
                searchNew({
                           'key': j$('#key').val()
                });
                return false;
            }
        }
    });

    j$('#lid').focus();
}

function searchNew(cond) {

    // キーワード
    if ((neolibura_search_type == 'key')
        && j$('#key').val().length < 1) {
        displayMsg('neolibura_nokey');
        return;
    }

    // savelogin
    if ((neolibura_search_type == 'lid')
        &&  (j$('#savelogin').attr('checked'))) {
        cond.savelogin = '1';
    }
    else {
        cond.savelogin = '0';
    }

    searchDoc(j$.extend({},
              cond,
              {
                'page': 1,
                'fromHistory': false
              }));
}

function searchHistoryKey(cond) {

    // 検索条件の復元
    cond.key = neolibura_search_cond_key.key;
    j$('#key').val(cond.key);

    neolibura_search_type = 'key';
    searchDoc(j$.extend({}, neolibura_search_cond_key, cond, {'fromHistory': true}));
}

function searchHistoryMydocs(cond) {

    // 検索条件の復元
    j$('#lid').val(neolibura_search_cond_mydocs.lid);
    j$('#pw').val('***************');

    if (neolibura_search_cond_mydocs.savelogin == '1') {
        j$('#savelogin').attr('checked', 'checked');
    }
    else {
        j$('#savelogin').attr('checked', '');
    }

    neolibura_search_type = 'lid';
    searchDoc(j$.extend({}, neolibura_search_cond_mydocs, cond, {'fromHistory': true}));
}

function searchDoc(cond) {

    // 検索条件のチェック
    if (cond == null) {
        return;
    }
    else if (neolibura_search_type == 'lid') {
        // lidで検索
        if (cond.lid == null) {
            cond.lid = '';
        }
        if (cond.pw == null) {
            cond.pw = '';
        }
    }
    else {
        // keyで検索
        if (cond.key == null) {
            cond.key = '';
        }
    }

    var index = (cond.page-1)*neolibura_view_count;

    // 画面表示を変更
    j$("html, body").scrollTop(0);
    j$('#id_loading').show();

    var objAjax = {
                type: 'post',
                timeout: 30000,
                dataType: 'jsonp',
                cache: false,
                url: tinyMCEPopup.getWindowArg('libura_api_url'),
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    displayMsg(textStatus);
                }
            };

    var objData = {
            'pg': 'dsrch',
            'mode': 'jsonp',
            'row': index,
            'num': neolibura_view_count
                };
    if (neolibura_search_type == 'lid') {
        j$.extend(neolibura_search_cond_mydocs, cond);

        objData = j$.extend(objData,
                            {
                                'lid': cond.lid,
                                'pw': cond.pw,
                                'savelogin': cond.savelogin,
                                'rte_neolibura_cky': tinyMCEPopup.getWindowArg('rte_neolibura_cky')
                            });
    }
    else {
        j$.extend(neolibura_search_cond_key, cond);

        objData = j$.extend(objData, {'key': cond.key});
    }
    objAjax = j$.extend(objAjax, {data: objData});
    j$.ajax(objAjax);

}

function displayMsg(error) {
    var ed = tinyMCEPopup.editor;
    var msg = ed.getLang('neolibura_dlg.msg_no_docs');

    // メッセージ
    if (error == 'neolibura_ng') {
        if (neolibura_search_type == 'lid') {
            msg = ed.getLang('neolibura_dlg.msg_no_user');
            j$('#pw').val('');
        }
        else {
            msg = ed.getLang('neolibura_dlg.msg_search_failed');
        }
    }
    else if (error == 'neolibura_nokey') {
        // キーワードなし
        msg = ed.getLang('neolibura_dlg.msg_no_key');
    }
    else if (error == 'timeout') {
        msg = ed.getLang('neolibura_dlg.msg_timeout');
    }
    else if (error != 'neolibura_nodocs') {
        msg = ed.getLang('neolibura_dlg.msg_error');
    }

    if (neolibura_search_type == 'lid') {
        j$('#id_docs_mydocs').empty();
        j$('.pager-container-mydocs').empty();

        j$('#id_docs_mydocs').hide();
        j$('.pager-container-mydocs').hide();

        j$('#no_docs_text_mydocs').html(msg);
        j$('#id_mydoc_help').hide();
        j$('#id_list_mydocs').hide();
        j$('#no_docs_mydocs').show();
    }
    else {
        j$('#id_docs_key').empty();
        j$('.pager-container-key').empty();

        j$('#id_docs_key').hide();
        j$('.pager-container-key').hide();

        j$('#no_docs_text_key').html(msg);
        j$('#id_list_key').hide();
        j$('#no_docs_key').show();
    }
    j$('#id_loading').hide();
}


function callback(data) {

    var sClass, sIdDocs, sTitle, sTitleLink;
    var ed = tinyMCEPopup.editor;

    // 一覧を初期化
    if (neolibura_search_type == 'lid') {
        j$('#id_docs_mydocs').empty();
        sIdDocs = '#id_docs_mydocs';
    }
    else {
        j$('#id_docs_key').empty();
        sIdDocs = '#id_docs_key';
    }

    var sStatus = data.feed.libura_status._t;
    if (sStatus != 'ok') {
        // エラー
        displayMsg('neolibura_ng');
        return;
    }

    neolibura_search_cond_key.total = parseInt(data.feed.libura_alldatacnt._t,10);

    if (neolibura_search_cond_key.total == 0) {
        // 0件の場合
        displayMsg('neolibura_nodocs');
        return;
    }

    j$.each(data.feed.entry, function(i,item) {

        sClass = 'public';
        if (item.libura_public._t == '0') {
            sClass = 'unpublic';
        }
        if (item.libura_public._t == '2') {
            sClass = 'group';
        }

        sTitle = encodeHtml(item.title._t);
        sTitleLink = breakString(item.title._t);

        var args = {
                    'gadget': item.libura_gadget.href,
                    'title': sTitle,
                    'public_status': item.libura_public._t,
                    'link': item.link.href
               };

        j$('<div/>').addClass('thumbnail ' + sClass)
          .append(j$('<a/>')
            .attr('class', 'md')
            .attr('href', item.libura_gadget.href)
            .attr('title', item.title._t)
            .attr('rel', 'width:500,height:375')
            .append(j$('<img />')
                .attr('src', item.libura_thumnail.href)))
          .append(j$('<br/>'))
          .append(j$('<div/>')
              .attr('class', 'thumbnail_title')
              .append(j$('<a/>')
                .attr('class', 'md')
                .attr('href', item.libura_gadget.href)
                .attr('rel', 'width:500,height:375')
                .attr('title', item.title._t)
                .append(sTitleLink)))
          .append(j$('<br/>'))
          .append(j$('<input/>')
            .attr('type', 'button')
            .attr('value',ed.getLang('neolibura_dlg.large'))
            .attr('class','btn_size')
            .click(function() { insertTag(j$.extend(args, {'size': 'l'})); }))
          .append(j$('<input/>')
            .attr('type', 'button')
            .attr('value',ed.getLang('neolibura_dlg.medium'))
            .attr('class','btn_size')
            .click(function() { insertTag(j$.extend(args, {'size': 'm'})); }))
          .append(j$('<input/>')
            .attr('type', 'button')
            .attr('value',ed.getLang('neolibura_dlg.small'))
            .attr('class','btn_size')
            .click(function() { insertTag(j$.extend(args, {'size': 's'})); }))
          .append(j$('<br/>'))
          .appendTo(sIdDocs);
    });

    // preview設定
    j$('.md').click(function() {

        j$('#basic-modal-content')
            .html(j$('<iframe/>')
                .attr('src', this.href)
                .attr('frameBorder', '0')
                .attr('width', '400')
                .attr('height', '300'));

        var sCloseHtml = '<a class="modalCloseImg" title="'
                       + ed.getLang('neolibura_dlg.close')
                       + '"></a>';

        j$('#basic-modal-content').modal
                ({
                    minWidth: 400,
                    minHeight: 300,
                    maxWidth: 800,
                    maxHeight: 600,
                    closeHTML: sCloseHtml,
                    overlayClose:true,
                    opacity: 60,
                    onClose: function (dialog) {
                        dialog.data.fadeOut('fast', function () {
                            dialog.container.fadeOut('fast', function () {
                                dialog.overlay.fadeOut('fast', function () {
                                    j$('#basic-modal-content').empty();
                                    j$.modal.close();
                                });
                            });
                        });
                    }
                });
        return false;
    });

    // pager
    var iLen = Math.ceil(parseInt(data.feed.libura_alldatacnt._t,10) / neolibura_view_count);

    if (neolibura_search_type == 'lid') {
        // キーワード検索結果
        j$('#id_list_key').hide();

        // メッセージを初期化
        j$('#no_docs_mydocs').hide();
        j$('#no_docs_text_mydocs').empty();

        // 自分のドキュメント一覧
        j$('.pager-container-mydocs').neoPager({
                            current: neolibura_search_cond_mydocs.page,
                            length: iLen,
                            messages: {
                                'prev': '<< 前の30件',
                                'paging': '$page$',
                                'next': '次の30件 >>'
                            },
                            onclick: function(event, page) {
                                    searchHistoryMydocs({'page': page});
                                }
                            });
        j$('#id_mydoc_help').show();
        j$('#id_docs_mydocs').show();
        j$('.pager-container-mydocs').show();
        j$('#id_list_mydocs').show();

    }
    else {
        // 自分のドキュメント一覧
        j$('#id_list_mydocs').hide();

        // メッセージを初期化
        j$('#no_docs_key').hide();
        j$('#no_docs_text_key').empty();

        // キーワード検索結果
        j$('#no_docs_key').hide();
        j$('.pager-container-key').neoPager({
                            current: neolibura_search_cond_key.page,
                            length: iLen,
                            messages: {
                                'prev': '<< 前の30件',
                                'paging': '$page$',
                                'next': '次の30件 >>'
                            },
                            onclick: function(event, page) {
                                    searchHistoryKey({'page': page});
                                }
                            });
        j$('#id_docs_key').show();
        j$('.pager-container-key').show();
        j$('#id_list_key').show();
    }

    j$('#id_loading').hide();
}

function insertTag(args) {
    var ed = tinyMCEPopup.editor;
    var iExp = parseFloat(tinyMCEPopup.getWindowArg('save_limit_time')) || 0;

    if (args.public_status != 1) {
        // 非公開ドキュメントを公開する場合

        // メッセージを表示するか確認
        if (j$.cookie('rte_neolibura_insert_unpublic_no_alert') != null) {
            // メッセージ表示不要
            insertTagDo(args);
        }
        else {
            jAlertchk(ed.getLang('neolibura_dlg.msg_insert_unpublic')
                      + '<input type="checkbox" class="popup_checkbox" value="1" id="popup_prompt" />&nbsp;'
                      + '<label for="popup_prompt">'
                      + ed.getLang('neolibura_dlg.msg_no_alert')
                      + '</label>', 
                      ed.getLang('neolibura_dlg.msg_insert_unpublic_title'),
                      function(bRet) {
                          if (bRet　==　null) {
                              // 次回も表示
                              j$.cookie('rte_neolibura_insert_unpublic_no_alert', null);
                              insertTagDo(args);
                          }
                          else{
                              // 今後はメッセージ不要
                              j$.cookie('rte_neolibura_insert_unpublic_no_alert',
                                        '1',
                                        { expires: iExp });
                              insertTagDo(args);
                          }
                      });
        }
    }
    else {
        insertTagDo(args);
    }
}

function insertTagDo(args) {
    var ed = tinyMCEPopup.editor;

    var arSize = {
        l:{width:'600', height:'450'},
        m:{width:'500', height:'375'},
        s:{width:'400', height:'300'}
    };

    var h = '<img src="' + tinyMCEPopup.getWindowArg("plugin_url") + '/../media/img/trans.gif"';
    h += ' class="mceItemLibura"';
    h += ' title="src:\'' + args.gadget + '\'"';
    h += ' width="' + arSize[args.size].width + '"';
    h += ' height="' + arSize[args.size].height + '"';
    h += ' align=""';
    h += ' />';

    ed.execCommand('mceInsertContent', false, h);

    tinyMCEPopup.close();
}

function encodeHtml(str) {
    return str.replace(/&/g, "&amp;")
          .replace(/</g, "&lt;")
          .replace(/>/g, "&gt;")
          .replace(/"/g, "&quot;")
          .replace(/ /g, "&nbsp;");
}

function breakString(str) {
    return str.replace(/(.)/g, '$1' + '<wbr />');
}

tinyMCEPopup.onInit.add(init);
